#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define cmpby(_x) [](const auto& a, const auto& b) {return (a _x) < (b _x);}
#define TASK_NAME "lamps"

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 1e5 + 5;

pii d[MAXN];
pii lamps[MAXN];
vector<int> graph[MAXN];

pii intersect(pii a, pii b) {
    return {max(a.ff, b.ff), min(a.ss, b.ss)};
}

int dfs(int v, int p) {
    bool flag = false;
    for (int to : graph[v]) {
        if (to != p) {
            dfs(to, v);
            if (!flag) {
                d[v] = {d[to].ff + lamps[to].ff, d[to].ss + lamps[to].ss};
                flag = true;
            } else {
                d[v] = intersect(d[v], {d[to].ff + lamps[to].ff, d[to].ss + lamps[to].ss});
            }
        }
    }

    if (d[v].ff > d[v].ss) {
        d[v].ss = -INF;
    }
    return 0;
}

int ans[MAXN];

int dfs2(int v, int p, int l, int r) {
    if (l > r) {
        r = -INF;
    }
    //cerr << "v: " << v << endl;
    //cerr << l << " " << r << endl;
    if (v == 0) {
        if (d[v].ff <= d[v].ss) {
            ans[v] = 1;
        }
        if (szof(graph[v]) != 1) {
            l = 0, r = INF;
        }
    } else {
        if (szof(graph[v]) == 1) {
            if (l <= r) {
                ans[v] = 1;
            }
        } else {
            if (max(l, d[v].ff) <= min(r, d[v].ss)) {
                ans[v] = 1;
            }
        }
    }

    vector<pii> rl;

    //cerr << "v: " << v << " " << l << " " << r << endl;
    for (int to : graph[v]) {
        if (to != p) {
            rl.puba({d[to].ff + lamps[to].ff, d[to].ss + lamps[to].ss});
            //cerr << rl.back().ff << " " << rl.back().ss << endl;
        }
    }

    rl.puba({0, INF});

    for (int i = szof(rl) - 2; i >= 0; --i) {
        rl[i] = intersect(rl[i], rl[i + 1]);
    }

    int c = 0;
    for (int to : graph[v]) {
        if (to != p) {
            dfs2(to, v, max(l, rl[c + 1].ff) + lamps[v].ff, min(r, rl[c + 1].ss) + lamps[v].ss);
            ++c;
            l = max(l, d[to].ff + lamps[to].ff);
            r = min(r, d[to].ss + lamps[to].ss);
        }
    }
    return 0;
}

int main() {
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);

    int n;
    scanf("%d", &n);

    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a; --b;
        graph[a].puba(b);
        graph[b].puba(a);
    }

    for (int i = 0; i < n; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        lamps[i] = {l, r};
    }

    dfs(0, -1);

    /*
    for (int i = 0; i < n; ++i) {
        cerr << "i: " << i << " " << d[i].ff << " " << d[i].ss << endl;
    }*/

    dfs2(0, -1, 0, 0);

    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    cout << "\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}