#include <cstdio>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int DIGITS = 10;

bool optimal(int i1, int j1, int i2, int j2)
{
    if (i1 > j1)
        swap(i1, j1);
    if (i2 > j2)
        swap(i2, j2);
    if (i1 == -1)
    {
        if (i2 == -1)
            return j1 < j2;
        else
            return true;
    } 
    else
    {
        if (i2 == -1)
            return false;
        else if (j1 == j2)
            return i1 < i2;
        else 
            return j1 < j2;
    }
}

int main()
{
    freopen("divisible.in", "r", stdin);
    freopen("divisible.out", "w", stdout);
    string s;
    cin >> s;
    vector<int> d(DIGITS, 0);
    int rem = 0;
    for (int i = 0; i < (int)s.size(); i++)
        d[s[i] - '0']++;
    for (int i = 0; i < DIGITS; i++)
        rem += i * d[i];
    rem %= 3;        
    int ansi = -2;
    int ansj = -2;
    for (int i = -1; i < DIGITS; i++)
        for (int j = i; j < DIGITS; j++)
        {
            if (i != -1 && d[i] == 0)
                continue;
            if (j != -1 && d[j] == 0)
                continue;
            if (i != -1 && i == j && d[i] < 2)
                continue;
            cerr << i << ' ' << j << endl;
            int remi = (i == -1) ? 0 : i % 3;    
            int remj = (j == -1) ? 0 : j % 3;
            if ((9 + rem - remi - remj) % 3 == 0)
            {
                if (ansi == -2 && ansj == -2)
                    ansi = i, ansj = j;
                else if (optimal(i, j, ansi, ansj))
                    ansi = i, ansj = j;
            }
        }
    cerr << ansi << ' ' << ansj << endl;
    if (ansi != -1)
        d[ansi]--;
    if (ansj != -1)
        d[ansj]--;
    for (int i = DIGITS - 1; i >= 0; i--)
        for (int j = 0; j < d[i]; j++)
            printf("%d", i);
    printf("\n");
    return 0;
}