/**
 *    author:  [itmo] enot.1.10
 *    created: 28.01.2017 02:41:52       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;

char s[N];
int cnt[10];


int main()
{
    assert(freopen("divisible.in", "r", stdin));
    assert(freopen("divisible.out", "w", stdout));
    scanf("%s", s);
    int n = strlen(s);
    forn(i, n) cnt[(int)(s[i] - '0')]++;
    int sum = 0;
    forn(i, 10) sum += cnt[i] * i;
    if (sum % 3 != 0)
    {   
        int s1 = sum % 3;
        int s2 = s1 ^ 3;
        forn(i, 10) while (i % 3 == s1 && cnt[i] && sum % 3 != 0)
        {
            cnt[i]--;
            sum -= i;
        }
        forn(i, 10) while (i % 3 == s2 && cnt[i] && sum % 3 != 0)
        {
            cnt[i]--;
            sum -= i;
        }
    }
    for (int i = 9; i >= 0; --i) forn(j, cnt[i]) printf("%d", i);
    puts("");


    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
